/* treke.f -- translated by f2c (version 19990311).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer l;
    real a, b;
    integer i__, iv, i7, i8, n;
    real distp, ajust;
    integer min__, istat, jtk, koenig, ignore, io;
    char na[2], igol[80];
} ccom_;

#define ccom_1 ccom_

struct {
    real dflct[4], dflck[8], dflcb[2];
} d_;

#define d_1 d_

struct {
    integer ionk[8], ispok[8], ion[4], ispot[4];
} i_;

#define i_1 i_

struct {
    integer iwho[8];
    real dist[8];
    integer killz, killr, killd, killg, igoco[8];
} k_;

#define k_1 k_

struct {
    integer ientr[4], ientc[4], iklnr[8], iklnc[8], igler[25], iglec[25], 
	    ibasr[2], ibasc[2], li2[4], li2r[5], li2c[5], igo[4], mines;
} l_;

#define l_1 l_

struct {
    char map[3600]	/* was [60][60] */, iblk[1], ienm1[8], iee[4], igle[1]
	    , im[4], iii[1], istar[1];
} mcom_;

#define mcom_1 mcom_

struct {
    char iname[48]	/* was [3][4] */, ienm2[128]	/* was [4][8] */, 
	    iside[24]	/* was [3][2] */;
    integer ibase[2];
} nn_;

#define nn_1 nn_

struct {
    integer iarmz[6], induz, ixryz, imagz, imagrz, iabsz, istaz, inviz[4], 
	    icloz, ionno, iplanz, irunz, idevz, idriz, imaxz;
} q_;

#define q_1 q_

struct {
    integer ichoe[4], ichos[8], ichob[2];
} t_;

#define t_1 t_

struct {
    integer launch, numout, nume[2];
} u_;

#define u_1 u_

struct {
    integer iweb[2], iwebz, invis[4];
} v_;

#define v_1 v_

struct {
    integer itom;
} tom_;

#define tom_1 tom_

struct {
    integer ibpsc[4], ibpsb[8], ibpss[2], ibpse[25];
} r_;

#define r_1 r_

struct {
    real zap[4];
    integer icola[4], irowa[4], lock[4], icoil[4];
} g_;

#define g_1 g_

struct {
    integer it, is, ii[2], ij[2], i3, js, ishak, nostop;
} a_;

#define a_1 a_

struct {
    integer ibpob[8], ibpoe[25];
} s_;

#define s_1 s_

/* Table of constant values */

static integer c__1 = 1;
static integer c__7 = 7;
static integer c__9 = 9;
static integer c__360 = 360;
static integer c_n90 = -90;
static integer c__90 = 90;
static integer c__270 = 270;
static integer c__5 = 5;
static integer c__10 = 10;
static integer c__100 = 100;
static integer c__6 = 6;

/* ==================================================== */
/* TREK7   MODULE E */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* ENTIRE MODULE TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/*  C-0 SHIP OPERATIONS */

/* ATACK   MORDOR  PIKE    DOOMVE  EDIBLE  MNERVA */
/* ASIMOV  NIVEN   WODEN   ALPHA   SIMAK   LEGUIN */

/* ==================================================== */
/*              -- DONALD ECCLESTONE SUBPROGRAM FOR     T R E K 7 */

/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/*                 AAA     TTTTT   AAA   CCC K   K */
/*                A   A      T    A   A C    K  K */
/*                AAAAA      T    AAAAA C    KKK */
/*                A   A      T    A   A C    K  K */
/*                A   A      T    A   A  CCC K   K */

/* Subroutine */ int atack_()
{
    /* Format strings */
    static char fmt_1970[] = "(\002 BEGIN ATACK I=\002,i4)";
    static char fmt_1972[] = "(\002 MIN=\002,i4,\002 I7=\002,i4,\002 I8=\002\
,i4,\002 DISTP=\002,f10.5)";
    static char fmt_1062[] = "(\002 THE KZINTI WARSHIP HAS RAMMED THE \002,3\
a4)";
    static char fmt_1030[] = "(\002 THERE HAS BEEN A BREAKDOWN IN THE ROMULA\
N WARSHIP'S CLO AKNG DEVICE\002/\002 AND THE SHIP CAN NOW BE PICKED UP BY OU\
R SENSORS\002)";

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();

    /* Local variables */
    static integer ivvv, itvl1;
    static real rtvl1;
    static integer j;
    extern /* Subroutine */ int alpha_();
    static real berng;
    extern /* Subroutine */ int rando_(), horta_(), niven_();
    static integer itzro;
    static real rtzro;
    static integer i71, i81, mm, mn;
    extern /* Subroutine */ int mnerva_(), asimov_();
    extern logical mordor_();
    static integer iq0;
    static real rad;
    static integer ivv;

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 6, 0, fmt_1970, 0 };
    static cilist io___7 = { 0, 6, 0, fmt_1972, 0 };
    static cilist io___15 = { 0, 6, 0, fmt_1062, 0 };
    static cilist io___18 = { 0, 6, 0, fmt_1030, 0 };


/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    for (ccom_1.i__ = 1; ccom_1.i__ <= 8; ++ccom_1.i__) {
	ccom_1.n = 4;
	k_1.dist[ccom_1.i__ - 1] = (float)100.;
	if (t_1.ichos[ccom_1.i__ - 1] != 1) {
	    goto L1000;
	}
	if (v_1.iweb[0] == ccom_1.i__ + 4) {
	    goto L1000;
	}
	if (v_1.iweb[1] == ccom_1.i__ + 4) {
	    goto L1000;
	}
	if (ccom_1.io == 1) {
	    s_wsfe(&io___1);
	    do_fio(&c__1, (char *)&ccom_1.i__, (ftnlen)sizeof(integer));
	    e_wsfe();
	}
	if (mordor_(&mm, &mn, &rad, &berng)) {
	    goto L1000;
	}
	if (ccom_1.i__ == 5 || ccom_1.i__ == 6) {
	    goto L10100;
	}
	goto L1010;
L1010:
	ccom_1.n = 4;
L10100:
	berng = berng * (float)3.14159265 / (float)180.;
	ccom_1.ajust = (float)0.;
	ccom_1.ignore = 0;
	ccom_1.iv = ccom_1.i__ + 4;
	if (q_1.ionno == 1 && ccom_1.i__ == 6) {
	    ccom_1.ignore = 1;
	}
	itzro = 0;
L10101:
	horta_(&l_1.iklnr[ccom_1.i__ - 1], &l_1.iklnc[ccom_1.i__ - 1], &mm, &
		mn, &rad, &berng, &itzro, &ccom_1.ajust, &ccom_1.ignore, &
		k_1.dist[ccom_1.i__ - 1], &itzro);
	if (ccom_1.io == 1) {
	    s_wsfe(&io___7);
	    do_fio(&c__1, (char *)&ccom_1.min__, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&ccom_1.i7, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&ccom_1.i8, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&ccom_1.distp, (ftnlen)sizeof(real));
	    e_wsfe();
	}
	if (ccom_1.min__ < 5) {
	    goto L101;
	}
	if (ccom_1.min__ < 15) {
	    goto L100;
	}
	if (ccom_1.min__ < 19) {
	    goto L103;
	}
	if (ccom_1.min__ == 19) {
	    goto L102;
	}
	if (ccom_1.min__ == 21) {
	    goto L106;
	}
L100:
	if (ccom_1.i__ > 3) {
	    goto L106;
	}
	ccom_1.ajust += (float).2617993;
	if (ccom_1.ajust > (float)6.283184) {
	    goto L107;
	}
	i_1.ionk[ccom_1.i__ - 1] = 0;
	ccom_1.ignore = 0;
	goto L10101;
L106:
	rad = rad - ccom_1.distp + (float)1.42;
	ivv = 0;
	if (q_1.ionno == 1 && ccom_1.i__ == 6) {
	    ccom_1.ignore = 1;
	}
L1060:
	ivvv = ccom_1.n;
	ccom_1.n = 2;
L10801:
	i81 = ccom_1.i8;
	i71 = ccom_1.i7;
	rtzro = (float)0.;
	itvl1 = 1;
	rtvl1 = (float)1.5;
	horta_(&i71, &i81, &l_1.iklnr[ccom_1.i__ - 1], &l_1.iklnc[ccom_1.i__ 
		- 1], &rtvl1, &rtzro, &itzro, &rtzro, &itvl1, &rtzro, &itzro);
	if (ccom_1.min__ != ccom_1.i__ + 4 && ccom_1.min__ != 19 && 
		ccom_1.min__ < 21) {
	    goto L10801;
	}
L1080:
	*(unsigned char *)&mcom_1.map[l_1.iklnr[ccom_1.i__ - 1] + l_1.iklnc[
		ccom_1.i__ - 1] * 60 - 61] = *(unsigned char *)mcom_1.iblk;
	if (i_1.ispok[ccom_1.i__ - 1] == 1) {
	    *(unsigned char *)&mcom_1.map[l_1.iklnr[ccom_1.i__ - 1] + 
		    l_1.iklnc[ccom_1.i__ - 1] * 60 - 61] = *(unsigned char *)
		    mcom_1.iii;
	}
	i_1.ispok[ccom_1.i__ - 1] = 0;
	l_1.iklnr[ccom_1.i__ - 1] = ccom_1.i7;
	l_1.iklnc[ccom_1.i__ - 1] = ccom_1.i8;
	if (*(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] == 
		*(unsigned char *)mcom_1.iii) {
	    i_1.ispok[ccom_1.i__ - 1] = 1;
	}
	if (ivv == 1) {
	    goto L10093;
	}
	if (ivv == 2) {
	    goto L10101;
	}
	ccom_1.n = ivvv;
	ccom_1.ajust += (float).7653981;
	if (ccom_1.ajust > (float)10.) {
	    goto L10093;
	}
	goto L10101;
L101:
	if (ccom_1.n == 5) {
	    goto L106;
	}
	if (ccom_1.n == 6) {
	    goto L1061;
	}
	ivv = 1;
	goto L1060;
L102:
	rad = (rad - ccom_1.distp) / (float)2.;
	i_1.ionk[ccom_1.i__ - 1] = 1;
	ccom_1.ignore = 1;
	ivv = 2;
	goto L1080;
L107:
	ivv = 1;
	goto L1060;
L103:
	mnerva_(&ccom_1.i__);
	ivv = 1;
	*(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] = *(
		unsigned char *)mcom_1.iblk;
	goto L1080;
/* L108: */
	ivv = 1;
	goto L1080;
L1061:
	for (ccom_1.iv = 1; ccom_1.iv <= 4; ++ccom_1.iv) {
	    if (t_1.ichoe[ccom_1.iv - 1] == 0) {
		goto L535;
	    }
	    ccom_1.l = ccom_1.iv + 4;
	    s_wsfe(&io___15);
	    for (iq0 = 1; iq0 <= 3; ++iq0) {
		do_fio(&c__1, nn_1.iname + (iq0 + ccom_1.min__ * 3 - 4 << 2), 
			(ftnlen)4);
	    }
	    e_wsfe();
L535:
	    ;
	}
	*(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] = *(
		unsigned char *)mcom_1.iblk;
	*(unsigned char *)&mcom_1.map[l_1.iklnr[5] + l_1.iklnc[5] * 60 - 61] =
		 *(unsigned char *)mcom_1.iblk;
	if (i_1.ispok[5] == 1) {
	    *(unsigned char *)&mcom_1.map[l_1.iklnr[5] + l_1.iklnc[5] * 60 - 
		    61] = *(unsigned char *)mcom_1.iii;
	}
	d_1.dflct[ccom_1.min__ - 1] = (float)-1.;
	d_1.dflck[5] = (float)-1.;
	ccom_1.istat = 2;
	return 0;
L10093:
	if (ccom_1.i__ != 6) {
	    goto L1063;
	}
	niven_();
	goto L1000;
L1063:
	asimov_(mcom_1.map + (l_1.iklnr[ccom_1.i__ - 1] + l_1.iklnc[
		ccom_1.i__ - 1] * 60 - 61), &ccom_1.i__, (ftnlen)1);
	if (ccom_1.i__ != 2) {
	    goto L1029;
	}
/* L1205: */
	ccom_1.n = d_1.dflck[ccom_1.i__ - 1] / (float)5.;
	if (ccom_1.n == 0) {
	    goto L672;
	}
	rando_(&j, &c__1, &ccom_1.n);
	if (j > 1) {
	    goto L1029;
	}
L672:
	for (ccom_1.iv = 1; ccom_1.iv <= 4; ++ccom_1.iv) {
	    if (t_1.ichoe[ccom_1.iv - 1] != 1) {
		goto L536;
	    }
	    ccom_1.l = ccom_1.iv + 4;
	    v_1.invis[ccom_1.iv - 1] = 1;
	    s_wsfe(&io___18);
	    e_wsfe();
L536:
	    ;
	}
L1029:
	*(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] = *(
		unsigned char *)&mcom_1.ienm1[ccom_1.i__ - 1];
L1000:
	;
    }
    if (t_1.ichos[7] == 0 && u_1.numout == 0) {
	return 0;
    }
    ccom_1.koenig = 1;
    alpha_();
    return 0;
} /* atack_ */

/* DONALD ECCLESTONE SUBPROGRAM FOR        T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - MORDOR */

/* -WHERE THE SHADOWS LIE */
logical mordor_(mm, mn, rad, berng)
integer *mm, *mn;
real *rad, *berng;
{
    /* Format strings */
    static char fmt_10032[] = "(\002 ROMULAN SHIP ATTACKING\002)";
    static char fmt_10033[] = "(\002 ROMULAN SHIP RETREATING\002)";

    /* System generated locals */
    integer i__1;
    real r__1;
    logical ret_val;

    /* Builtin functions */
    integer s_wsfe(), e_wsfe();
    double atan();

    /* Local variables */
    extern /* Subroutine */ int pike_();
    static integer j;
    extern /* Subroutine */ int rando_();
    static integer imaxz, idriz, idevz, irunz;
    extern doublereal di_();
    static integer i71;
    extern /* Subroutine */ int doomve_(), dunsel_();
    static integer iplanz;
    extern doublereal ang_();
    static integer ivv;

    /* Fortran I/O blocks */
    static cilist io___22 = { 0, 6, 0, fmt_10032, 0 };
    static cilist io___23 = { 0, 6, 0, fmt_10033, 0 };


/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    ret_val = TRUE_;
    pike_(&l_1.iklnr[ccom_1.i__ - 1], &l_1.iklnc[ccom_1.i__ - 1], &r_1.ibpsb[
	    ccom_1.i__ - 1]);
    if (ccom_1.min__ == 0) {
	goto L1000;
    }
    k_1.dist[ccom_1.i__ - 1] = ccom_1.distp;
    k_1.iwho[ccom_1.i__ - 1] = ccom_1.min__;
    if (ccom_1.i__ == 8) {
	goto L1000;
    }
    if (ccom_1.min__ > 4) {
	goto L500;
    }
    *mm = l_1.ientr[ccom_1.min__ - 1];
    *mn = l_1.ientc[ccom_1.min__ - 1];
    ccom_1.a = d_1.dflct[ccom_1.min__ - 1];
    goto L501;
L500:
    if (ccom_1.min__ > 6) {
	goto L502;
    }
    ccom_1.i7 = ccom_1.min__ - 4;
    *mm = l_1.ibasr[ccom_1.i7 - 1];
    *mn = l_1.ibasc[ccom_1.i7 - 1];
    ccom_1.a = d_1.dflcb[ccom_1.i7 - 1];
    goto L501;
L502:
    if (ccom_1.min__ > 14) {
	goto L503;
    }
    ccom_1.i7 = ccom_1.min__ - 6;
    *mm = l_1.iklnr[ccom_1.i7 - 1];
    *mn = l_1.iklnc[ccom_1.i7 - 1];
    ccom_1.a = d_1.dflck[ccom_1.i7 - 1];
    goto L501;
L503:
    ccom_1.i7 = ccom_1.min__ - 14;
    *mm = l_1.igler[ccom_1.i7 - 1];
    *mn = l_1.iglec[ccom_1.i7 - 1];
    ccom_1.a = (float)0.;
L501:
    ccom_1.ajust = (float)0.;
    i_1.ionk[ccom_1.i__ - 1] = 0;
    switch ((int)ccom_1.i__) {
	case 1:  goto L1006;
	case 2:  goto L1001;
	case 3:  goto L1002;
	case 4:  goto L1007;
	case 5:  goto L1011;
	case 6:  goto L110;
	case 7:  goto L1012;
    }
L1006:
    rando_(&j, &c__7, &c__9);
    if (k_1.dist[ccom_1.i__ - 1] <= (float)1.5) {
	goto L1000;
    }
    *rad = (real) j;
L1005:
    ccom_1.ajust = (float)0.;
L1009:
    if (r_1.ibpsb[ccom_1.i__ - 1] == 0 || k_1.igoco[ccom_1.i__ - 1] == 0) {
	goto L600;
    }
    ccom_1.distp = (float)100.;
    ivv = 0;
    for (ccom_1.iv = 1; ccom_1.iv <= 4; ++ccom_1.iv) {
	if (t_1.ichoe[ccom_1.iv - 1] != 1 || (r_1.ibpsc[ccom_1.iv - 1] + 1) / 
		2 != r_1.ibpsb[ccom_1.i__ - 1]) {
	    goto L601;
	}
	ccom_1.b = di_(&l_1.iklnr[ccom_1.i__ - 1], &l_1.iklnc[ccom_1.i__ - 1],
		 &l_1.ientr[ccom_1.iv - 1], &l_1.ientc[ccom_1.iv - 1]);
	if (ccom_1.b > ccom_1.distp) {
	    goto L601;
	}
	ivv = ccom_1.iv;
	ccom_1.distp = ccom_1.b;
L601:
	;
    }
    if (ivv == 0) {
	goto L600;
    }
    *mm = l_1.ientr[ivv - 1];
    *mn = l_1.ientc[ivv - 1];
    ccom_1.ajust = (float)0.;
    ccom_1.n = 4;
L600:
    ccom_1.iv = *mm - l_1.iklnr[ccom_1.i__ - 1];
    ivv = *mn - l_1.iklnc[ccom_1.i__ - 1];
    *berng = ang_(&ccom_1.iv, &ivv);
/* L1101: */
    *berng += ccom_1.ajust;
    if (*berng < (float)0.) {
	*berng += (float)360.;
    }
    if (*berng > (float)360.) {
	*berng += (float)-360.;
    }
    for (ccom_1.i7 = 1; ccom_1.i7 <= 4; ++ccom_1.i7) {
	if (t_1.ichoe[ccom_1.i7 - 1] != 1) {
	    goto L504;
	}
	dunsel_(&l_1.iklnr[ccom_1.i__ - 1], &l_1.iklnc[ccom_1.i__ - 1], rad, 
		berng);
L504:
	;
    }
    ret_val = FALSE_;
L1000:
    return ret_val;
L1001:
    rando_(&j, &c__7, &c__9);
    *rad = (real) j;
    ccom_1.iv = k_1.killr;
    for (j = 1; j <= 4; ++j) {
/* L10010: */
	v_1.invis[j - 1] = 0;
    }
    if (ccom_1.distp <= (float)10. || k_1.killr != 1) {
	k_1.killr = 2;
    }
    if (ccom_1.a - d_1.dflck[1] > (float)20.) {
	k_1.killr = 3;
    }
    ccom_1.iv -= k_1.killr;
    i71 = ccom_1.min__ + 4;
    switch ((int)k_1.killr) {
	case 1:  goto L1003;
	case 2:  goto L10031;
	case 3:  goto L1004;
    }
L1003:
    rando_(&j, &c__1, &c__360);
    *berng = (real) j;
    goto L1009;
L10031:
    rando_(&j, &c_n90, &c__90);
    ccom_1.ajust = (real) j;
/* old      IF(MIN.LT.5.AND.IV.NE.0)WRITE(I71,10032) */
    if (ccom_1.min__ < 5 && ccom_1.iv != 0) {
	s_wsfe(&io___22);
	e_wsfe();
    }
    goto L1009;
L1004:
    rando_(&j, &c__90, &c__270);
    ccom_1.ajust = (real) j;
/* old      IF(MIN.LT.5.AND.IV.NE.0)WRITE(I71,10033) */
    if (ccom_1.min__ < 5 && ccom_1.iv != 0) {
	s_wsfe(&io___23);
	e_wsfe();
    }
    goto L1009;
L1002:
    if (ccom_1.distp <= (float)8.) {
	goto L1000;
    }
    rando_(&j, &c__5, &c__10);
    *rad = (real) j;
    if (ccom_1.distp - (float)8. < *rad) {
	*rad = ccom_1.distp - (float)6.5;
    }
    goto L1005;
L1007:
    *rad = (float)11.;
    k_1.killg = 1;
    if (d_1.dflck[3] - ccom_1.a < (float)25.) {
	k_1.killg = 2;
    }
    if (k_1.killg == 1) {
	goto L1005;
    }
/* L1008: */
    ccom_1.ajust = (float)180.;
    goto L1009;
L1011:
    *rad = (float)12.;
L123:
    ccom_1.ajust = (r__1 = atan((float)1.1 / ccom_1.distp), dabs(r__1)) * (
	    float)180. / (float)3.14159265;
    ccom_1.n = 5;
    goto L1009;
L110:
    *rad = (real) imaxz;
    ccom_1.n = 4;
    if (idriz == 1) {
	ccom_1.istat = 11;
    }
    if (k_1.killz == 100) {
	goto L124;
    }
    if (ccom_1.distp <= (real) k_1.killz) {
	goto L125;
    }
    rando_(&ccom_1.i7, &c__1, &c__360);
    ccom_1.ajust = (real) ccom_1.i7;
    goto L1009;
L125:
    k_1.killz = 100;
L124:
    switch ((int)iplanz) {
	case 1:  goto L121;
	case 2:  goto L122;
	case 3:  goto L123;
    }
L121:
    ccom_1.ajust = (float)0.;
    if (ccom_1.a - d_1.dflck[5] > (real) irunz) {
	ccom_1.ajust = (float)180.;
    }
    i__1 = -idevz;
    rando_(&ccom_1.i7, &i__1, &idevz);
    ccom_1.ajust += ccom_1.i7;
    goto L1009;
L122:
    ccom_1.ajust = (float)0.;
    ccom_1.n = 6;
    goto L1009;
L1012:
    doomve_(mm, mn);
    goto L1000;
} /* mordor_ */

/* -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - PIKE - */

/* Subroutine */ int pike_(j1, j2, j3)
integer *j1, *j2, *j3;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    extern doublereal di_();
    static integer ivv;

/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    ccom_1.distp = (float)100.;
    ccom_1.min__ = 0;
    for (ivv = 1; ivv <= 4; ++ivv) {
	if (t_1.ichoe[ivv - 1] == 0 || t_1.ichoe[ivv - 1] == 3) {
	    goto L1;
	}
	if (*j3 == (r_1.ibpsc[ivv - 1] + 1) / 2) {
	    goto L1;
	}
	ccom_1.ajust = di_(j1, j2, &l_1.ientr[ivv - 1], &l_1.ientc[ivv - 1]);
	if (ccom_1.ajust >= ccom_1.distp) {
	    goto L1;
	}
	if (ccom_1.ajust == (float)0.) {
	    goto L1;
	}
	ccom_1.distp = ccom_1.ajust;
	ccom_1.min__ = ivv;
L1:
	;
    }
    for (ivv = 1; ivv <= 2; ++ivv) {
	if (t_1.ichob[ivv - 1] == 0) {
	    goto L2;
	}
	if (*j3 == r_1.ibpss[ivv - 1]) {
	    goto L2;
	}
	ccom_1.ajust = di_(j1, j2, &l_1.ibasr[ivv - 1], &l_1.ibasc[ivv - 1]);
	if (ccom_1.ajust >= ccom_1.distp) {
	    goto L2;
	}
	if (ccom_1.ajust == (float)0.) {
	    goto L2;
	}
	if (*j3 == 0 && a_1.ij[r_1.ibpss[ivv - 1] - 1] == 0) {
	    goto L2;
	}
	ccom_1.distp = ccom_1.ajust;
	ccom_1.min__ = ivv + 4;
L2:
	;
    }
    for (ivv = 1; ivv <= 8; ++ivv) {
	if (t_1.ichos[ivv - 1] != 1) {
	    goto L3;
	}
	if (*j3 == r_1.ibpsb[ivv - 1]) {
	    goto L3;
	}
	ccom_1.ajust = di_(j1, j2, &l_1.iklnr[ivv - 1], &l_1.iklnc[ivv - 1]);
	if (ccom_1.ajust >= ccom_1.distp) {
	    goto L3;
	}
	if (ccom_1.ajust == (float)0.) {
	    goto L3;
	}
	if (ivv != 2) {
	    goto L10;
	}
	if (v_1.invis[(*j3 << 1) - 2] + v_1.invis[(*j3 << 1) - 1] == 0 || 
		ccom_1.ajust > (float)5.) {
	    goto L3;
	}
	goto L11;
L10:
	if (ivv != 6 || q_1.iarmz[4] == 0) {
	    goto L11;
	}
	if (q_1.inviz[(*j3 << 1) - 2] + q_1.inviz[(*j3 << 1) - 1] == 0 || 
		ccom_1.ajust > (real) q_1.icloz) {
	    goto L3;
	}
L11:
	ccom_1.distp = ccom_1.ajust;
	ccom_1.min__ = ivv + 6;
L3:
	;
    }
/* L4: */
    if (u_1.numout == 0) {
	return 0;
    }
    i__1 = u_1.launch;
    for (ivv = 1; ivv <= i__1; ++ivv) {
	if (l_1.igler[ivv - 1] == 0) {
	    goto L5;
	}
	if (*j3 == r_1.ibpse[ivv - 1]) {
	    goto L5;
	}
	ccom_1.ajust = di_(j1, j2, &l_1.igler[ivv - 1], &l_1.iglec[ivv - 1]);
	if (ccom_1.ajust >= ccom_1.distp) {
	    goto L5;
	}
	if (ccom_1.ajust == (float)0.) {
	    goto L5;
	}
	ccom_1.distp = ccom_1.ajust;
	ccom_1.min__ = ivv + 14;
L5:
	;
    }
    return 0;
} /* pike_ */

/*          DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 */
/*              CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/*                - DOOMVE - */

/* Subroutine */ int doomve_(mm, mn)
integer *mm, *mn;
{
    /* Format strings */
    static char fmt_521[] = "(\002 THE DOOMSDAY MACHINE HAS EATEN \002,3a4\
,\002 STARBASE\002,i3)";
    static char fmt_523[] = "(\002 THE DOOMSDAY MACHINE HAS JUST EATEN A MIN\
E - NO DAMAGE\002)";
    static char fmt_527[] = "(\002 THE DOOMSDAY MACHINE HAS EATEN THE \002,3\
a4)";
    static char fmt_532[] = "(\002 THE DOOMSDAY MACHINE HAS EATEN THE \002,4\
a4)";
    static char fmt_534[] = "(\002 THE DOOMSDAY MACHINE HAS EATEN EAGLE\002,\
i3)";

    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();

    /* Local variables */
    extern /* Subroutine */ int boom_();
    static integer ivvv, j;
    extern /* Subroutine */ int rando_();
    static integer i71, i81;
    extern integer edible_();
    extern /* Subroutine */ int mnerva_();
    static integer iq0, ivv;

    /* Fortran I/O blocks */
    static cilist io___35 = { 0, 6, 0, fmt_521, 0 };
    static cilist io___37 = { 0, 6, 0, fmt_523, 0 };
    static cilist io___38 = { 0, 6, 0, fmt_527, 0 };
    static cilist io___39 = { 0, 6, 0, fmt_532, 0 };
    static cilist io___40 = { 0, 6, 0, fmt_534, 0 };


/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
/* L1012: */
    ccom_1.ignore = (integer) ccom_1.distp;
    i__1 = ccom_1.ignore;
    for (ccom_1.n = ccom_1.i__; ccom_1.n <= i__1; ++ccom_1.n) {
	ivvv = l_1.iklnr[6] - ccom_1.n + 1;
	ivv = l_1.iklnr[6] + ccom_1.n - 1;
	i71 = l_1.iklnc[6] - ccom_1.n;
	i81 = l_1.iklnc[6] + ccom_1.n;
	if (ivvv < 1) {
	    ivvv = 1;
	}
	if (i71 < 1) {
	    i71 = 1;
	}
	if (ivv > 60) {
	    ivv = 60;
	}
	if (i81 > 60) {
	    i81 = 60;
	}
	ccom_1.i7 = l_1.iklnr[6] - ccom_1.n;
	if (ccom_1.i7 < 1) {
	    goto L507;
	}
	i__2 = i81;
	for (ccom_1.i8 = i71; ccom_1.i8 <= i__2; ++ccom_1.i8) {
	    j = edible_(mm, mn);
	    if (j > 0) {
		goto L510;
	    }
/* L508: */
	}
L507:
	ccom_1.i7 = l_1.iklnr[6] + ccom_1.n;
	if (ccom_1.i7 > 60) {
	    goto L509;
	}
	i__2 = i81;
	for (ccom_1.i8 = i71; ccom_1.i8 <= i__2; ++ccom_1.i8) {
	    j = edible_(mm, mn);
	    if (j > 0) {
		goto L510;
	    }
/* L511: */
	}
L509:
	ccom_1.i8 = l_1.iklnc[6] - ccom_1.n;
	if (ccom_1.i8 < 1) {
	    goto L512;
	}
	i__2 = ivv;
	for (ccom_1.i7 = ivvv; ccom_1.i7 <= i__2; ++ccom_1.i7) {
	    j = edible_(mm, mn);
	    if (j > 0) {
		goto L510;
	    }
/* L513: */
	}
L512:
	ccom_1.i8 = l_1.iklnc[6] + ccom_1.n;
	if (ccom_1.i8 > 60) {
	    goto L506;
	}
	i__2 = ivv;
	for (ccom_1.i7 = ivvv; ccom_1.i7 <= i__2; ++ccom_1.i7) {
	    j = edible_(mm, mn);
	    if (j > 0) {
		goto L510;
	    }
/* L515: */
	}
L506:
	;
    }
    ccom_1.i7 = *mm;
    ccom_1.i8 = *mn;
    goto L517;
L510:
    ccom_1.iv = l_1.iklnc[6];
    ivv = l_1.iklnr[6];
    *(unsigned char *)&mcom_1.map[ivv + ccom_1.iv * 60 - 61] = *(unsigned 
	    char *)mcom_1.iblk;
    if (i_1.ispok[6] == 1) {
	*(unsigned char *)&mcom_1.map[ivv + ccom_1.iv * 60 - 61] = *(unsigned 
		char *)mcom_1.iii;
    }
    i_1.ispok[6] = 0;
    l_1.iklnc[6] = ccom_1.i8;
    l_1.iklnr[6] = ccom_1.i7;
    *(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] = *(
	    unsigned char *)&mcom_1.ienm1[6];
    switch ((int)j) {
	case 1:  goto L514;
	case 2:  goto L516;
	case 3:  goto L517;
    }
L514:
    for (ccom_1.iv = 1; ccom_1.iv <= 5; ++ccom_1.iv) {
	if (ccom_1.i7 != l_1.li2r[ccom_1.iv - 1]) {
	    goto L516;
	}
	if (ccom_1.i8 != l_1.li2c[ccom_1.iv - 1]) {
	    goto L516;
	}
	l_1.li2c[ccom_1.iv - 1] = 0;
	l_1.li2r[ccom_1.iv - 1] = 0;
	goto L1000;
/* L518: */
    }
    for (ccom_1.iv = 1; ccom_1.iv <= 2; ++ccom_1.iv) {
	if (ccom_1.i7 != l_1.ibasr[ccom_1.iv - 1]) {
	    goto L519;
	}
	if (ccom_1.i8 != l_1.ibasc[ccom_1.iv - 1]) {
	    goto L519;
	}
L529:
	d_1.dflcb[ccom_1.iv - 1] = (float)-1.;
	ccom_1.istat = 2;
	for (ivv = 1; ivv <= 4; ++ivv) {
	    if (t_1.ichoe[ivv - 1] == 0) {
		goto L5190;
	    }
	    i71 = ivv + 4;
/* old      WRITE(I71,521)(ISIDE(IQ0,IV),IQ0=1,3),IBASE(IV) */
	    s_wsfe(&io___35);
	    for (iq0 = 1; iq0 <= 3; ++iq0) {
		do_fio(&c__1, nn_1.iside + (iq0 + ccom_1.iv * 3 - 4 << 2), (
			ftnlen)4);
	    }
	    do_fio(&c__1, (char *)&nn_1.ibase[ccom_1.iv - 1], (ftnlen)sizeof(
		    integer));
	    e_wsfe();
L5190:
	    ;
	}
L519:
	;
    }
    goto L1000;
L516:
    rando_(&ccom_1.iv, &c__1, &c__7);
    if (ccom_1.iv > 2) {
	goto L520;
    }
    for (j = 1; j <= 4; ++j) {
	if (t_1.ichoe[j - 1] == 0) {
	    goto L522;
	}
	ccom_1.iv = j + 4;
/* old        WRITE(IV,523) */
	s_wsfe(&io___37);
	e_wsfe();
L522:
	;
    }
    goto L1000;
L520:
    mnerva_(&c__7);
    goto L1000;
L517:
    ccom_1.istat = 2;
    if (ccom_1.min__ > 4) {
	goto L525;
    }
    d_1.dflct[ccom_1.min__ - 1] = (float)-1.;
    for (ivv = 1; ivv <= 4; ++ivv) {
	if (t_1.ichoe[ivv - 1] == 0) {
	    goto L526;
	}
	ccom_1.iv = ivv + 4;
/* old        WRITE(IV,527)(INAME(IQ0,MIN),IQ0=1,3) */
	s_wsfe(&io___38);
	for (iq0 = 1; iq0 <= 3; ++iq0) {
	    do_fio(&c__1, nn_1.iname + (iq0 + ccom_1.min__ * 3 - 4 << 2), (
		    ftnlen)4);
	}
	e_wsfe();
L526:
	;
    }
    goto L1000;
L525:
    if (ccom_1.min__ > 6) {
	goto L528;
    }
    ccom_1.iv = ccom_1.min__ - 4;
    goto L529;
L528:
    if (ccom_1.min__ > 14) {
	goto L530;
    }
    ccom_1.min__ += -6;
    d_1.dflck[ccom_1.min__ - 1] = (float)-1.;
    for (ivv = 1; ivv <= 4; ++ivv) {
	if (t_1.ichoe[ivv - 1] == 0) {
	    goto L531;
	}
	ccom_1.iv = ivv + 4;
/* old        WRITE(IV,532)(IENM2(J,MIN),J=1,4) */
	s_wsfe(&io___39);
	for (j = 1; j <= 4; ++j) {
	    do_fio(&c__1, nn_1.ienm2 + (j + (ccom_1.min__ << 2) - 5 << 2), (
		    ftnlen)4);
	}
	e_wsfe();
L531:
	;
    }
    goto L1000;
L530:
    ccom_1.min__ += -14;
    boom_(&ccom_1.min__);
    for (ivv = 1; ivv <= 4; ++ivv) {
	if (t_1.ichoe[ivv - 1] == 0) {
	    goto L533;
	}
	ccom_1.iv = ivv + 4;
/* old        WRITE(IV,534)MIN */
	s_wsfe(&io___40);
	do_fio(&c__1, (char *)&ccom_1.min__, (ftnlen)sizeof(integer));
	e_wsfe();
L533:
	;
    }
    goto L1000;
L1000:
    return 0;
} /* doomve_ */

/*       -- DONALD ECCLESTONE SUBPROGRAM FOR     T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/*                       - EDIBLE - */

integer edible_(mm, mn)
integer *mm, *mn;
{
    /* System generated locals */
    integer ret_val;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer s_cmp();

    /* Local variables */
    static integer ik;

/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    ret_val = 0;
    s_copy(ccom_1.na, mcom_1.map + (ccom_1.i7 + ccom_1.i8 * 60 - 61), (ftnlen)
	    2, (ftnlen)1);
    if (s_cmp(ccom_1.na, mcom_1.iblk, (ftnlen)2, (ftnlen)1) == 0 || s_cmp(
	    ccom_1.na, mcom_1.iii, (ftnlen)2, (ftnlen)1) == 0) {
	return ret_val;
    }
    if (s_cmp(ccom_1.na, mcom_1.istar, (ftnlen)2, (ftnlen)1) != 0) {
	goto L1;
    }
    for (ik = 1; ik <= 2; ++ik) {
	if (*mm == l_1.ibasr[ik - 1] && *mn == l_1.ibasc[ik - 1] && a_1.ij[
		r_1.ibpss[ik - 1] - 1] == 0) {
	    return ret_val;
	}
/* L3: */
    }
    ret_val = 1;
    return ret_val;
L1:
    if (s_cmp(ccom_1.na, "1", (ftnlen)2, (ftnlen)1) < 0 || s_cmp(ccom_1.na, 
	    "4", (ftnlen)2, (ftnlen)1) > 0) {
	goto L2;
    }
    ret_val = 2;
    return ret_val;
L2:
    if (*mm != ccom_1.i7) {
	return ret_val;
    }
    if (*mn == ccom_1.i8) {
	ret_val = 3;
    }
    return ret_val;
} /* edible_ */

/* -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - MNERVA - */

/* Subroutine */ int mnerva_(j)
integer *j;
{
    /* Format strings */
    static char fmt_401[] = "(1x,4a4,\002 HAS COLLIDED WITH A MINE - DAMAGE \
REPORT-\002)";

    /* Builtin functions */
    double log();
    integer s_wsfe(), do_fio(), e_wsfe();

    /* Local variables */
    extern /* Subroutine */ int grup3_(), rando_();
    static integer ivv;

    /* Fortran I/O blocks */
    static cilist io___43 = { 0, 6, 0, fmt_401, 0 };


/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    rando_(&ccom_1.iv, &c__10, &c__100);
    ivv = (integer) (log(((float)101. - d_1.dflck[*j - 1]) * ccom_1.iv + (
	    float)10.) / (float).700619195 - (float)1.8185);
    for (ccom_1.iv = 1; ccom_1.iv <= 4; ++ccom_1.iv) {
	if (t_1.ichoe[ccom_1.iv - 1] == 0) {
	    goto L141;
	}
	ccom_1.l = ccom_1.iv + 4;
	s_wsfe(&io___43);
	for (ccom_1.n = 1; ccom_1.n <= 4; ++ccom_1.n) {
	    do_fio(&c__1, nn_1.ienm2 + (ccom_1.n + (*j << 2) - 5 << 2), (
		    ftnlen)4);
	}
	e_wsfe();
L141:
	;
    }
    grup3_(&ivv, j);
    --l_1.mines;
    return 0;
} /* mnerva_ */

/* -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - ASIMOV - */

/* Subroutine */ int asimov_(na, k, na_len)
char *na;
integer *k;
ftnlen na_len;
{
    if (*(unsigned char *)na != *(unsigned char *)mcom_1.iii) {
	return 0;
    }
    i_1.ionk[*k - 1] = 1;
    i_1.ispok[*k - 1] = 1;
    return 0;
} /* asimov_ */

/* -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - NIVEN - */

/* Subroutine */ int niven_()
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    extern /* Subroutine */ int rando_();
    extern logical woden_();
    extern /* Subroutine */ int asimov_();
    static integer ivv;

/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
/* L85: */
    if (q_1.iarmz[3] == 0) {
	goto L81;
    }
    if (q_1.imagz == 0) {
	goto L81;
    }
    ccom_1.min__ = 0;
    i__1 = q_1.imagz;
    for (ccom_1.n = 1; ccom_1.n <= i__1; ++ccom_1.n) {
L87:
	i__2 = -q_1.imagrz;
	rando_(&ccom_1.iv, &i__2, &q_1.imagrz);
	i__2 = -q_1.imagrz;
	rando_(&ivv, &i__2, &q_1.imagrz);
	++ccom_1.min__;
	if (ccom_1.min__ > 20) {
	    goto L81;
	}
	ccom_1.iv = l_1.iklnr[5] + ccom_1.iv;
	ivv = l_1.iklnc[5] + ivv;
	if (! woden_(&ccom_1.iv, &ivv, mcom_1.map + (ccom_1.iv + ivv * 60 - 
		61), (ftnlen)1)) {
	    goto L87;
	}
	ccom_1.min__ = 0;
/* L86: */
	*(unsigned char *)&mcom_1.map[ccom_1.iv + ivv * 60 - 61] = *(unsigned 
		char *)&mcom_1.ienm1[5];
    }
    for (ccom_1.min__ = 1; ccom_1.min__ <= 20; ++ccom_1.min__) {
	i__1 = l_1.iklnr[5] - 3;
	i__2 = l_1.iklnr[5] + 3;
	rando_(&ccom_1.iv, &i__1, &i__2);
	i__1 = l_1.iklnc[5] - 3;
	i__2 = l_1.iklnc[5] + 3;
	rando_(&ivv, &i__1, &i__2);
	if (! woden_(&ccom_1.iv, &ivv, mcom_1.map + (ccom_1.iv + ivv * 60 - 
		61), (ftnlen)1)) {
	    goto L83;
	}
	l_1.iklnr[5] = ccom_1.iv;
	l_1.iklnc[5] = ivv;
	goto L88;
L83:
	;
    }
L88:
    asimov_(mcom_1.map + (l_1.iklnr[5] + l_1.iklnc[5] * 60 - 61), &c__6, (
	    ftnlen)1);
L81:
    *(unsigned char *)&mcom_1.map[l_1.iklnr[5] + l_1.iklnc[5] * 60 - 61] = *(
	    unsigned char *)&mcom_1.ienm1[5];
    return 0;
} /* niven_ */

/* -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - WODEN - */

logical woden_(i__, j, na, na_len)
integer *i__, *j;
char *na;
ftnlen na_len;
{
    /* System generated locals */
    logical ret_val;

    /* Local variables */
    extern logical cyrano_();

    ret_val = FALSE_;
    if (cyrano_(i__, j)) {
	return ret_val;
    }
    if (*(unsigned char *)na != *(unsigned char *)mcom_1.iblk && *(unsigned 
	    char *)na != *(unsigned char *)mcom_1.iii && *(unsigned char *)na 
	    != *(unsigned char *)&mcom_1.ienm1[5]) {
	return ret_val;
    }
    ret_val = TRUE_;
    return ret_val;
} /* woden_ */

/*       -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* checked type-exact 04/24/2000 by DG */

/*               - ALPHA - */

/* Subroutine */ int alpha_()
{
    /* Format strings */
    static char fmt_1978[] = "(\002 BEGIN ALPHA J1=\002,i5,\002 J2=\002,i5\
,\002 BDIS=\002,f10.5)";
    static char fmt_1979[] = "(\002 =#=\002,i3,\002 MIN=\002,i5,\002 I7=\002\
,i5,\002 I8=\002,i5)";
    static char fmt_8[] = "(\002 EAGLE\002,i3,\002 DESTROYED ON COLLISION WI\
TH A MINE\002)";

    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    integer s_wsfe(), do_fio(), e_wsfe();

    /* Local variables */
    static real bdis;
    extern /* Subroutine */ int boom_();
    static real rtvl1, berng;
    extern /* Subroutine */ int simak_(), horta_();
    static integer j1, j2, i4, itzro;
    static real rtzro;
    extern doublereal di_();
    static integer i71, i81;
    extern /* Subroutine */ int leguin_();
    extern doublereal ang_();
    static real rad;
    static integer ivv;

    /* Fortran I/O blocks */
    static cilist io___48 = { 0, 6, 0, fmt_1978, 0 };
    static cilist io___54 = { 0, 6, 0, fmt_1979, 0 };
    static cilist io___59 = { 0, 6, 0, fmt_8, 0 };


/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    simak_(&j1, &j2);
    ccom_1.istat = 0;
    ccom_1.i__ = 0;
    ccom_1.iv = 0;
    bdis = di_(&j1, &j2, &l_1.iklnr[7], &l_1.iklnc[7]);
    if (ccom_1.io == 1) {
	s_wsfe(&io___48);
	do_fio(&c__1, (char *)&j1, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&j2, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&bdis, (ftnlen)sizeof(real));
	e_wsfe();
    }
    i__1 = u_1.launch;
    for (ivv = 1; ivv <= i__1; ++ivv) {
	if (l_1.igler[ivv - 1] == 0) {
	    goto L2;
	}
	rad = (float)2.9;
	ccom_1.i7 = j1 - l_1.igler[ivv - 1];
	ccom_1.i8 = j2 - l_1.iglec[ivv - 1];
	if (bdis <= (float)5.) {
	    goto L18;
	}
	if (abs(ccom_1.i7) <= 3 && abs(ccom_1.i8) <= 3) {
	    goto L2;
	}
L18:
	berng = ang_(&ccom_1.i7, &ccom_1.i8) * (float)3.14159265 / (float)
		180.;
	ccom_1.ajust = (float)0.;
L7:
	ccom_1.n = 4;
	ccom_1.ignore = 0;
	itzro = 0;
	rtzro = (float)0.;
/* old  CALL HORTA(IGLER(IVV),IGLEC(IVV), */
/* old *itzro,itzro,RAD,BERNG,itzro,AJUST,IGNORE,itzro,itzro) */
	horta_(&l_1.igler[ivv - 1], &l_1.iglec[ivv - 1], &itzro, &itzro, &rad,
		 &berng, &itzro, &ccom_1.ajust, &ccom_1.ignore, &rtzro, &
		itzro);
	if (ccom_1.io == 1) {
	    s_wsfe(&io___54);
	    do_fio(&c__1, (char *)&ivv, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&ccom_1.min__, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&ccom_1.i7, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&ccom_1.i8, (ftnlen)sizeof(integer));
	    e_wsfe();
	}
	if (ccom_1.min__ >= 15 && ccom_1.min__ <= 18) {
	    goto L5;
	}
	if (ccom_1.min__ == 21) {
	    goto L10;
	}
	ccom_1.i__ = 1;
	rad = rad - ccom_1.distp + (float)1.42;
	ccom_1.ajust += (float).785398163;
	if (ccom_1.ajust > (float)7.) {
	    goto L2;
	}
	ccom_1.n = 2;
	i4 = 0;
L6:
	i71 = ccom_1.i7;
	i81 = ccom_1.i8;
	ccom_1.ignore = 0;
	++i4;
	rtzro = (float)0.;
	itzro = 0;
	rtvl1 = (float)1.5;
	horta_(&i71, &i81, &l_1.igler[ivv - 1], &l_1.iglec[ivv - 1], &rtvl1, &
		rtzro, &itzro, &rtzro, &ccom_1.ignore, &itzro, &itzro);
/* L1981: */
	if (ccom_1.min__ == 14 && ccom_1.i7 == l_1.igler[ivv - 1] && 
		ccom_1.i8 == l_1.iglec[ivv - 1]) {
	    goto L11;
	}
	if (ccom_1.min__ < 21) {
	    goto L6;
	}
L11:
	*(unsigned char *)&mcom_1.map[l_1.igler[ivv - 1] + l_1.iglec[ivv - 1] 
		* 60 - 61] = *(unsigned char *)mcom_1.iblk;
	*(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] = *(
		unsigned char *)mcom_1.igle;
	l_1.igler[ivv - 1] = ccom_1.i7;
	l_1.iglec[ivv - 1] = ccom_1.i8;
	if (ccom_1.i__ == 1) {
	    goto L7;
	}
	goto L2;
L5:
	for (i71 = 1; i71 <= 4; ++i71) {
	    if (t_1.ichoe[i71 - 1] == 0) {
		goto L12;
	    }
	    i81 = i71 + 4;
/* old        WRITE(I81,8)IVV */
	    s_wsfe(&io___59);
	    do_fio(&c__1, (char *)&ivv, (ftnlen)sizeof(integer));
	    e_wsfe();
L12:
	    ;
	}
	*(unsigned char *)&mcom_1.map[ccom_1.i7 + ccom_1.i8 * 60 - 61] = *(
		unsigned char *)mcom_1.iblk;
	boom_(&ivv);
	--l_1.mines;
	goto L2;
L10:
	ccom_1.i__ = 0;
	goto L11;
L2:
	;
    }
    if (u_1.launch < 25 && t_1.ichos[7] != 0) {
	leguin_(&j1, &j2);
    }
    return 0;
} /* alpha_ */

/* DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - SIMAK - */

/* Subroutine */ int simak_(j1, j2)
integer *j1, *j2;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    extern doublereal di_();
    static integer i71, i81;

/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    i71 = l_1.iklnr[7];
    i81 = l_1.iklnc[7];
    i__1 = u_1.launch;
    for (ccom_1.i__ = 1; ccom_1.i__ <= i__1; ++ccom_1.i__) {
	if (l_1.igler[ccom_1.i__ - 1] == 0) {
	    goto L13;
	}
	i71 = l_1.igler[ccom_1.i__ - 1];
	i81 = l_1.iglec[ccom_1.i__ - 1];
	goto L14;
L13:
	;
    }
L14:
    ccom_1.ajust = (float)100.;
    ccom_1.jtk = 0;
    for (ccom_1.i7 = 1; ccom_1.i7 <= 4; ++ccom_1.i7) {
	if (t_1.ichoe[ccom_1.i7 - 1] == 0) {
	    goto L15;
	}
	ccom_1.distp = di_(&l_1.ientr[ccom_1.i7 - 1], &l_1.ientc[ccom_1.i7 - 
		1], &i71, &i81);
	if (ccom_1.distp > ccom_1.ajust) {
	    goto L15;
	}
	ccom_1.ajust = ccom_1.distp;
	ccom_1.jtk = ccom_1.i7;
L15:
	;
    }
/* L16: */
    *j1 = l_1.ientr[ccom_1.jtk - 1];
    *j2 = l_1.ientc[ccom_1.jtk - 1];
    return 0;
} /* simak_ */

/* -- DONALD ECCLESTONE SUBPROGRAM FOR T R E K 7 -- */
/*  CONVERTED TO PC BY: DAN GAHLINGER */
/* TYPE-EXACT CHECK 04/27/2000 BY: D.G. */

/* - LEGUIN - */

/* Subroutine */ int leguin_(j3, j4)
integer *j3, *j4;
{
    /* Format strings */
    static char fmt_103[] = "(\002 EAGLE\002,i3,\002 CRASHED INTO \002,3a4\
,\002 ON TAKE-OFF\002/\002 EAGLE\002,i3,\002 DESTROYED\002/1x,3a4,\002 DAMAG\
E REPORT-\002)";
    static char fmt_104[] = "(\002 EAGLE\002,i3,\002 DESTROYED ON COLLISION \
WITH A MINE\002)";

    /* Builtin functions */
    double sin(), cos();
    integer s_wsfe(), do_fio(), e_wsfe();
    double log();

    /* Local variables */
    extern /* Subroutine */ int grup1_(), simak_(), rando_();
    static integer j1, j2, i71, i81, iq0, ivv;

    /* Fortran I/O blocks */
    static cilist io___67 = { 0, 6, 0, fmt_103, 0 };
    static cilist io___69 = { 0, 6, 0, fmt_104, 0 };


/* cc      COMMON /C/L,A,B,I,NA,IV,I7,I8,N,DISTP,AJUST,MIN,ISTAT,JTK,KOENIG, */
/* cc     *IGNORE,IO,IGOL(80) */
    j1 = *j3;
    j2 = *j4;
    if (j1 == 0) {
	simak_(&j1, &j2);
    }
    i71 = j1 - l_1.iklnr[7];
    ivv = j2 - l_1.iklnc[7];
    ccom_1.distp = (float).785396163;
    if (i71 == 0) {
	ccom_1.distp = (float)0.;
    }
    if (ivv == 0) {
	ccom_1.distp *= (float)2.;
    }
    if (ivv < 0) {
	ccom_1.distp = (float)3.14159265 - ccom_1.distp;
    }
    if (i71 < 0) {
	ccom_1.distp = -ccom_1.distp;
    }
    ccom_1.ajust = (float)0.;
    i81 = 1;
    ccom_1.i8 = u_1.launch + 1;
L107:
    if (ccom_1.i8 > 25) {
	goto L113;
    }
    i71 = (integer) (sin(ccom_1.distp + ccom_1.ajust) * (float)1.8) + 
	    l_1.iklnr[7];
    ivv = (integer) (cos(ccom_1.distp + ccom_1.ajust) * (float)1.8) + 
	    l_1.iklnc[7];
    if (*(unsigned char *)&mcom_1.map[i71 + ivv * 60 - 61] == *(unsigned char 
	    *)mcom_1.iblk) {
	goto L105;
    }
/* L101: */
    for (ccom_1.jtk = 1; ccom_1.jtk <= 4; ++ccom_1.jtk) {
	if (*(unsigned char *)&mcom_1.map[i71 + ivv * 60 - 61] == *(unsigned 
		char *)&mcom_1.iee[ccom_1.jtk - 1]) {
	    goto L123;
	}
	if (*(unsigned char *)&mcom_1.map[i71 + ivv * 60 - 61] == *(unsigned 
		char *)&mcom_1.im[ccom_1.jtk - 1]) {
	    goto L102;
	}
/* L122: */
    }
    goto L110;
L123:
    for (ccom_1.min__ = 1; ccom_1.min__ <= 4; ++ccom_1.min__) {
	if (t_1.ichoe[ccom_1.min__ - 1] == 0) {
	    goto L124;
	}
	ccom_1.n = ccom_1.min__ + 4;
/* old      WRITE(N,103)I8,(INAME(IQ0,JTK),IQ0=1,3),I8, */
	s_wsfe(&io___67);
	do_fio(&c__1, (char *)&ccom_1.i8, (ftnlen)sizeof(integer));
	for (iq0 = 1; iq0 <= 3; ++iq0) {
	    do_fio(&c__1, nn_1.iname + (iq0 + ccom_1.jtk * 3 - 4 << 2), (
		    ftnlen)4);
	}
	do_fio(&c__1, (char *)&ccom_1.i8, (ftnlen)sizeof(integer));
	for (iq0 = 1; iq0 <= 3; ++iq0) {
	    do_fio(&c__1, nn_1.iname + (iq0 + ccom_1.jtk * 3 - 4 << 2), (
		    ftnlen)4);
	}
	e_wsfe();
L124:
	;
    }
    rando_(&ccom_1.iv, &c__1, &c__100);
    j1 = log(((float)101. - d_1.dflct[ccom_1.jtk - 1]) * ccom_1.iv + (float)
	    10.) / (float).700619195 - (float)1.8185;
    grup1_(&j1, &ccom_1.jtk);
    --u_1.numout;
    l_1.igler[ccom_1.i8 - 1] = 0;
    l_1.iglec[ccom_1.i8 - 1] = 0;
    goto L106;
L102:
    for (j1 = 1; j1 <= 4; ++j1) {
	if (t_1.ichoe[j1 - 1] == 0) {
	    goto L125;
	}
	j2 = j1 + 4;
/* old        WRITE(J2,104)I8 */
	s_wsfe(&io___69);
	do_fio(&c__1, (char *)&ccom_1.i8, (ftnlen)sizeof(integer));
	e_wsfe();
L125:
	;
    }
    *(unsigned char *)&mcom_1.map[i71 + ivv * 60 - 61] = *(unsigned char *)
	    mcom_1.iblk;
    --l_1.mines;
    --u_1.numout;
    l_1.igler[ccom_1.i8 - 1] = 0;
    l_1.iglec[ccom_1.i8 - 1] = 0;
    goto L106;
L105:
    *(unsigned char *)&mcom_1.map[i71 + ivv * 60 - 61] = *(unsigned char *)
	    mcom_1.igle;
    l_1.igler[ccom_1.i8 - 1] = i71;
    l_1.iglec[ccom_1.i8 - 1] = ivv;
    if (s_1.ibpob[7] == 0) {
	goto L1060;
    }
    s_1.ibpob[7] += -2;
    ++u_1.nume[r_1.ibpsb[7] - 1];
    ++a_1.ii[r_1.ibpsb[7] - 1];
    s_1.ibpoe[ccom_1.i8 - 1] = 2;
    r_1.ibpse[ccom_1.i8 - 1] = r_1.ibpsb[7];
    goto L106;
L1060:
    ++a_1.i3;
L106:
    ++i81;
    ++ccom_1.i8;
L110:
    if (ccom_1.ajust > (float)0.) {
	goto L111;
    }
    ccom_1.ajust = (float).765398163 - ccom_1.ajust;
    goto L112;
L111:
    ccom_1.ajust = -ccom_1.ajust;
L112:
    if (ccom_1.ajust > (float)-6.28 && i81 <= 5) {
	goto L107;
    }
L113:
    u_1.launch = u_1.launch + i81 - 1;
    u_1.numout = u_1.numout + i81 - 1;
/* L120: */
    return 0;
} /* leguin_ */

